=== debian/control ===
Source: libjodycode
Section: libs
Priority: optional
Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.6.2
Homepage: https://github.com/jbruchon/libjodycode
Vcs-Browser: https://salsa.debian.org/debian/libjodycode
Vcs-Git: https://salsa.debian.org/debian/libjodycode.git

Package: libjodycode3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libjodycode2 (<= 2.0.1-4)
Breaks: libjodycode2 (<= 2.0.1-4)
Description: shared lib for programs written by Jody Bruchon (runtime)
 libjodycode is a software code library containing code shared among several
 of the programs written by Jody Bruchon such as imagepile, jdupes, winregfs,
 and zeromerge. These shared pieces of code were copied between each program
 as they were updated. As the number of programs increased and keeping these
 pieces of code synced became more annoying, the decision was made to combine
 all of them into a single reusable shared library.
 .
 This package provides the runtime for libjodycode.

Package: libjodycode-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, libjodycode3 (= ${binary:Version})
Replaces: libjodycode2-dev (<= 2.0.1-4), libjodycode3-dev (<= 3.0.1-2)
Breaks: libjodycode2-dev (<= 2.0.1-4), libjodycode3-dev (<= 3.0.1-2)
Description: shared lib for programs written by Jody Bruchon (development files)
 libjodycode is a software code library containing code shared among several
 of the programs written by Jody Bruchon such as imagepile, jdupes, winregfs,
 and zeromerge. These shared pieces of code were copied between each program
 as they were updated. As the number of programs increased and keeping these
 pieces of code synced became more annoying, the decision was made to combine
 all of them into a single reusable shared library.
 .
 This package provides the development files for libjodycode.
