=== debian/watch ===
version=4
https://github.com/jbruchon/libjodycode/tags .*/tags/v?(\d\S+)\.tar\.(?:bz2|gz|xz)
