=== debian/changelog ===
libjodycode (3.1.1-2deepin1) unstable; urgency=medium

  * Revert 64-bit time_t changes.

 -- Tianyu Chen <sweetyfish@deepin.org>  Fri, 21 Feb 2025 16:31:55 +0800

libjodycode (3.1.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 02 Aug 2024 14:35:24 -0300

libjodycode (3.1.1-1) experimental; urgency=medium

  * New upstream version 3.1.1.
  * debian/control: bumped Standards-Version to 4.7.0.
  * debian/copyright:
      - Added new rights in packaging stanza.
      - Removed a reference for orig_headers/jody_oom.h, no longer in source
        code.
      - Updated upstream and packaging copyright years.
  * debian/libjodycode3t64.lintian-overrides: removed. The upstream fixed the
    source code. Thanks!
  * debian/libjodycode3t64.symbols: added a new symbol.
  * debian/tests/control: using libjodycode3t64 as dependency. Thanks to
    Matthias Klose <doko@ubuntu.com>.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 02 Aug 2024 00:49:01 -0300

libjodycode (3.1-6.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062385

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 13:29:05 +0000

libjodycode (3.1-6) unstable; urgency=medium

  * jdupes has a new repository (Codeberg). Consequently:
      - debian/control: updated the Homepage field.
      - debian/copyright: updated Upstream-Contact and Source fields.
      - debian/upstream/metadata: updated all data.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 14 Nov 2023 10:54:49 -0300

libjodycode (3.1-5) unstable; urgency=medium

  * debian/watch: updated because the upstream moved the project from GitHub
    to Codeberg.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 06 Oct 2023 21:56:55 -0300

libjodycode (3.1-4) unstable; urgency=medium

  * debian/libjodycode3.symbols: changed the tags of the last four symbols from
    "optional" to "arch=amd64".

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 08 Aug 2023 12:52:16 -0300
