=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13)
-Standards-Version: 4.6.2
-Homepage: https://github.com/jbruchon/libjodycode
+Standards-Version: 4.7.0
+Homepage: https://codeberg.org/jbruchon/libjodycode
 Vcs-Browser: https://salsa.debian.org/debian/libjodycode
 Vcs-Git: https://salsa.debian.org/debian/libjodycode.git
