=== debian/changelog ===
libjodycode (4.0.1-7~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 04 Oct 2025 16:47:52 -0300

libjodycode (4.0.1-7) unstable; urgency=medium

  * debian/tests/control: updated dependencies in CI tests.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 29 Sep 2025 20:40:30 -0300

libjodycode (4.0.1-6) unstable; urgency=medium

  * Upload to unstable.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 28 Sep 2025 14:19:23 -0300

libjodycode (4.0.1-5) experimental; urgency=medium

  * debian/libjodycode4.symbols: adjusted some symbols for hurd-*.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 27 Sep 2025 15:03:23 -0300

libjodycode (4.0.1-4) experimental; urgency=medium

  * Using libjodycode4 instead of libjodycode4t64. Thanks to Sebastian Ramacher
    <sramacher@debian.org> for the guidance. Consequently:
      - debian/control:
          ~ Changed from libjodycode4t64 to libjodycode4 in the binary name.
          ~ Dropped the Provides field.
          ~ Updated Replaces, Brakes and Depends fields.
      - debian/libjodycode4t64.docs: renamed to debian/libjodycode4.docs.
      - debian/libjodycode4t64.install: renamed to debian/libjodycode4.install.
      - debian/libjodycode4t64.symbols: renamed to debian/libjodycode4.symbols.
      - debian/libjodycode4.symbols: updated the header.
      - Closes: #1116297

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Thu, 25 Sep 2025 08:11:57 -0300

libjodycode (4.0.1-3) unstable; urgency=medium

  * Upload to unstable.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 23 Sep 2025 20:16:45 -0300

libjodycode (4.0.1-2) experimental; urgency=medium

  * debian/libjodycode4t64.symbols: set a symbol for Linux only to avoid a
    FTBFS on Hurd.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 23 Sep 2025 12:33:10 -0300

libjodycode (4.0.1-1) experimental; urgency=medium

  * New upstream version 4.0.1.
  * Replaced libjodycode3t64 by libjodycode4t64. Consequently:
      - debian/control:
          ~ Renamed the binary name.
          ~ Updated Depends, Replaces and Breaks fields.
      - debian/libjodycode3t64.docs: renamed to debian/libjodycode4t64.docs.
      - debian/libjodycode3t64.install: renamed to libjodycode4t64.install.
      - debian/libjodycode3t64.symbols: renamed to libjodycode4t64.symbols.
      - debian/libjodycode4t64.symbols: updated symbols.
  * debian/control: removed no longer needed "Rules-Requires-Root: no" field.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 21 Sep 2025 13:50:01 -0300

libjodycode (3.1.2-1) unstable; urgency=medium

  * New upstream version 3.1.2.
  * debian/control: bumped Standards-Version to 4.7.2.
  * debian/copyright: updated upstream and packaging copyright years.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 25 Mar 2025 22:11:15 -0300
