=== debian/changelog ===
libjodycode (4.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 14 Oct 2025 16:48:07 -0300

libjodycode (4.1-1) experimental; urgency=medium

  * New upstream version 4.1.
  * debian/libjodycode4.symbols: added new symbols.
  * debian/patches/:
      - 010_fix-FTBFS.patch: created to fix a FTBFS. Thanks to Jody Bruchon
        <jody@jodybruchon.com>.
      - 020_fix-manpage-level.patch: created to change level from 7 to 3.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 14 Oct 2025 00:04:02 -0300

libjodycode (4.0.1-8) unstable; urgency=medium

  [ Joao Eriberto Mota Filho ]
  * debian/copyright: added rights for Sebastian Ramacher
    <sramacher@debian.org>.
  * debian/tests/: added 3 new CI tests, from jdupes package, to
    check the bugs #1030933 and #1063079.

  [ Sebastian Ramacher ]
  * Moved devel manpage to -dev package to make libjodycode{3,4,...}
    co-installable. Consequently:
      - debian/libjodycode-dev.install: removed usr/share.
      - debian/libjodycode4.install: added usr/share.
  * debian/control: removed no longer necessary Breaks+Replaces.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 06 Oct 2025 03:54:48 -0300
